package org.chir.swing;

import java.awt.*;
import java.awt.geom.*;
import javax.swing.*;

/** Swing JList with an icon next to every item. */
public class ComponentList extends JList
{
	// Display an icon and a string for each object in the list.

    private class MyCellRenderer implements ListCellRenderer
    {
         // This is the only method defined by ListCellRenderer.
         // We just reconfigure the JLabel each time we're called.
         public Component getListCellRendererComponent(
           JList list,
           Object value,            // value to display
           int index,               // cell index
           boolean isSelected,      // is the cell selected
           boolean cellHasFocus )   // the list and the cell have the focus
         {
            Component c = (Component)value; // !!! cast.

            if( isSelected )
            {
                c.setBackground(list.getSelectionBackground());
                c.setForeground(list.getSelectionForeground());
            }
            else
            {
                c.setBackground(list.getBackground());
                c.setForeground(list.getForeground());
            }
            c.setEnabled(list.isEnabled());
            c.setFont(list.getFont());
//            c.setOpaque(true);
            return c;
         }
	}

    public ComponentList()
    {
        setCellRenderer( new MyCellRenderer() );
    }
}
